
;--------------------------------------------------------;
; File fontwin.asm                                       ;
; Applicazione Win32 standard dotata di Main Window      ;
;--------------------------------------------------------;

; ################# direttive per l'assembler #################

.386                                   ; set di istruzioni a 32 bit
.MODEL      FLAT, STDCALL              ; memory model & calling conventions
OPTION      CASEMAP: NONE              ; case sensitive on symbols

; ############### dichiarazione tipi e costanti ###############

; ########################## macro ############################

; trasferimento dati da mem32 a mem32

MOV32 MACRO Destinazione, Sorgente

   push     Sorgente
   pop      Destinazione

ENDM

; crea un dato di tipo COLORREF

MAKE_COLORREF MACRO intRed, intGreen, intBlue

   xor      eax, eax                   ; eax = 0
   mov      ah, intBlue
   shl      eax, 8                     ; eax = 00h, Blue, 00h, 00h
   mov      ah, intGreen               ; eax = 00h, Blue, Green, 00h
   mov      al, intRed                 ; eax = 00h, Blue, Green, Red

ENDM

; #################### inclusione librerie ####################

INCLUDE     ..\include\win32.inc       ; header file principale di Win32
INCLUDE     ..\include\user32.inc      ; interfaccia per USER32.LIB
INCLUDE     ..\include\kernel32.inc    ; interfaccia per KERNEL32.LIB
INCLUDE     ..\include\gdi32.inc       ; interfaccia per GDI32.LIB

INCLUDELIB  ..\lib\import32.lib        ; libreria generale

; ################# prototipi delle procedure #################

WinMain     PROTO    :DWORD, :DWORD, :DWORD, :DWORD
SetFont     PROTO    :DWORD
MemSet      PROTO    :DWORD, :DWORD, :DWORD
StrCpy      PROTO    :DWORD, :DWORD

; ################ segmento dati inizializzati #################

_DATA       SEGMENT  DWORD PUBLIC USE32 'DATA'

className      db       'FontWin', 0
winTitle       db       'Win32 Assembly - Applicazione FontWin', 0

msgTitolo      db       'Win 32 Assembly', 0
msgCreate      db       'Procedura FontWin_OnCreate.', 10
               db       'Messaggio WM_CREATE ricevuto!', 10
               db       'Inizializzazioni effettuate.', 0

msgClose       db       'Procedura FontWin_OnClose.', 10       
               db       'Messaggio WM_CLOSE ricevuto!', 10
               db       'Chiudere FONTWIN.EXE ?', 0

strOut1        db       'Output di stringhe di testo in Win32'
LEN_STROUT1    =        $ - offset strOut1
strOut2        db       'True Type'
LEN_STROUT2    =        $ - offset strOut2
strOut3        db       'Testo centrato nella finestra', 0

fontName       db       'Times New Roman', 0
fontHandle     dd       0

_DATA       ENDS

; ############## segmento dati non inizializzati ##############

_BSS        SEGMENT  DWORD PUBLIC USE32 'BSS'

hInstance      dd       ?                 ; handle dell'applicazione
commandLine    dd       ?                 ; puntatore alla command line
hWindow        dd       ?                 ; handle della main window

fontStruct     LOGFONT  <?>               ; struttura LOGFONT

_BSS        ENDS

; ##################### segmento di codice #####################

_TEXT       SEGMENT DWORD PUBLIC USE32 'CODE'

start:                                 ; entry point del programma

; ----------------- blocco inizializzazioni --------------------

   call     GetModuleHandle, NULL      ; trova l'handle del modulo FONTWIN.EXE
   mov      hInstance, eax             ; e lo salva in hInstance

   call     GetCommandLine             ; trova l'indirizzo della command line
   mov      commandLine, eax           ; e lo salva in commandLine

; ------------ blocco definizione della main window ------------

   call     WinMain, hInstance, NULL, commandLine, SW_SHOWNORMAL

; ---------------- blocco deinizializzazioni -------------------

   call     ExitProcess, eax           ; exit code restituito da WinMain

; ---------------- inizio blocco procedure ---------------------

;----------------------------------------------------------------------------------;
; int WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow) ;
;----------------------------------------------------------------------------------;
; Procedura principale dell'applicazione FONTNWIN.ASM. All'interno di WinMain si   ;
; svolgono le fasi di inizializzazione, registrazione, attivazione e gestione      ;
; della Main Window.                                                               ;
;----------------------------------------------------------------------------------;

WinMain proc hInst :DWORD, hPrevInst :DWORD, lpCmdLine :DWORD, nCmdShow :DWORD

   LOCAL    wc       :WNDCLASSEX       ; crea wc nello stack
   LOCAL    msg      :MSG              ; crea msg nello stack

; inizializzazione main window

   lea      eax, wc
   call     MemSet, eax, 0, SIZE WNDCLASSEX        ; inizializza wc con zeri

   mov      wc.wc_cbSize, SIZE WNDCLASSEX          ; dimensioni struttura
   mov      wc.wc_style, CS_HREDRAW OR CS_VREDRAW  ; stile della win. class
   mov      wc.wc_lpfnWndProc, offset WndProc      ; indirizzo window procedure
   mov      wc.wc_cbClsExtra, 0                    ; byte extra per la win. class
   mov      wc.wc_cbWndExtra, 0                    ; byte extra per la win. instance
   MOV32    wc.wc_hInstance, hInstance             ; handle dell'applicazione
   call     LoadIcon, NULL, IDI_INFORMATION        ; eax = handle icona
   mov      wc.wc_hIcon, eax                       ; icona dell'applicazione
   call     LoadCursor, NULL, IDC_HAND             ; eax = handle cursore
   mov      wc.wc_hCursor, eax                     ; cursore dell'applicazione
   MAKE_COLORREF 0, 150, 150                       ; crea una terna RGB
   call     CreateSolidBrush, eax                  ; e la converte in HBRUSH
   mov      wc.wc_hbrBackground, eax               ; colore di sfondo della finestra
   mov      wc.wc_lpszClassName, offset className  ; nome della classe finestra
   mov      wc.wc_hIconSm, NULL                    ; icona piccola dell'applicazione

; registrazione main window

   lea      eax, wc
   call     RegisterClassEx, eax                   ; richiesta di registrazione
   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0

; attivazione della main window

   call     CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, \    ; stile esteso finestra
                            offset className, \          ; nome window class
                            offset winTitle, \           ; titolo finestra
                            WS_OVERLAPPEDWINDOW, \       ; stile ordinario finestra
                            10, \                        ; x vertice superiore sinistro
                            10, \                        ; y vertice superiore sinistro
                            600, \                       ; larghezza finestra
                            550, \                       ; altezza finestra
                            NULL, \                      ; handle finestra madre
                            NULL, \                      ; codice menu
                            hInstance, \                 ; handle applicazione
                            NULL                         ; puntatore a CREATESTRUCT

   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0
   mov      hWindow, eax                           ; salva l'HWND della finestra in hWindow
   call     ShowWindow, hWindow, nCmdShow          ; visualizza la finestra
   call     UpdateWindow, hWindow                  ; aggiorna l'area client
   test     eax, eax                               ; errore ?
   jz       exitWinMain                            ; termina con eax = 0

; gestione della main window

MessageLoop:
   lea      eax, msg   
   call     GetMessage, eax, NULL, 0, 0            ; estrazione prossimo messaggio
   test     eax, eax                               ; eax = 0 ?
   jz       exitMessageLoop                        ; fine del loop (WM_QUIT)
   lea      eax, msg
   call     TranslateMessage, eax                  ; decodifica messaggio
   lea      eax, msg
   call     DispatchMessage,  eax                  ; invio messaggio alla WinProc
   jmp      MessageLoop                            ; ripeti
exitMessageLoop:

   mov      eax, msg.ms_wParam                     ; exit code = OK

exitWinMain:                                       ; exit code = 0 (errore)

   ret

WinMain endp

;------------- prototipi per WndProc -------------

FontWin_OnCreate  PROTO :DWORD, :DWORD
FontWin_OnPaint   PROTO :DWORD
FontWin_OnClose   PROTO :DWORD
FontWin_OnDestroy PROTO :DWORD

;----------------------------------------------------------------------------------;
; LRESULT WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)              ;
;----------------------------------------------------------------------------------;
; Window procedure della Main Window dell'applicazione FONTWIN.ASM. WndProc viene  ;
; utilizzata dal SO per inviare i messaggi alla Main Window.                       ;
;----------------------------------------------------------------------------------;

WndProc proc hWnd :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD

messaggio_WM_CREATE:
   cmp      uMsg, WM_CREATE            ; (uMsg == WM_CREATE) ?
   jne      messaggio_WM_PAINT
   call     FontWin_OnCreate, hWnd, lParam
   jmp      messaggio_restituito       ; passa WM_CREATE a DefWindowProc
messaggio_WM_PAINT:
   cmp      uMsg, WM_PAINT             ; (uMsg == WM_PAINT) ?
   jne      messaggio_WM_CLOSE
   call     FontWin_OnPaint, hWnd
   jmp      exitWndProc
messaggio_WM_CLOSE:
   cmp      uMsg, WM_CLOSE             ; (uMsg == WM_CLOSE) ?
   jne      messaggio_WM_DESTROY
   call     FontWin_OnClose, hWnd
   cmp      eax, IDYES                 ; conferma chiusura programma ?
   jne      exitWndProc
   jmp      messaggio_restituito       ; passa WM_CLOSE a DefWindowProc
messaggio_WM_DESTROY:
   cmp      uMsg, WM_DESTROY           ; (uMsg == WM_DESTROY) ?
   jne      messaggio_restituito
   call     FontWin_OnDestroy, hWnd
   jmp      exitWndProc
messaggio_restituito:
   call     DefWindowProc, hWnd, uMsg, wParam, lParam
   ret
exitWndProc:

   xor      eax, eax
   ret

WndProc endp

; ------------- procedure usate da WndProc ------------

;-------------------------------------------------------------;
; BOOL Cls_OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) ;
;-------------------------------------------------------------;
; risposta al messaggio WM_CREATE                             ;
;-------------------------------------------------------------;

FontWin_OnCreate proc hwnd :DWORD, lpCreateStruct :DWORD

   call     MemSet, offset fontStruct, 0, SIZE LOGFONT

   mov      fontStruct.lfHeight, 50
   mov      fontStruct.lfWeight, 700
   mov      fontStruct.lfEscapement, 0
   mov      fontStruct.lfItalic, TRUE
   mov      fontStruct.lfUnderline, TRUE
   mov      fontStruct.lfCharSet, ANSI_CHARSET
   mov      fontStruct.lfOutPrecision, OUT_TT_ONLY_PRECIS
   mov      fontStruct.lfClipPrecision, CLIP_DEFAULT_PRECIS
   mov      fontStruct.lfQuality, DEFAULT_QUALITY
   mov      fontStruct.lfPitchAndFamily, VARIABLE_PITCH OR FF_ROMAN
   call     StrCpy, offset fontStruct.lfFaceName, offset fontName
   
   call     MessageBox, hwnd, offset msgCreate, offset msgTitolo, MB_OK OR MB_ICONINFORMATION

   mov      eax, TRUE
   ret

FontWin_OnCreate endp

;-----------------------------------------------------;
; void Cls_OnPaint(HWND hwnd);                        ;
;-----------------------------------------------------;
; risposta al messaggio WM_PAINT                      ;
;-----------------------------------------------------;

FontWin_OnPaint proc hwnd :DWORD

   LOCAL    paintStruct :PAINTSTRUCT   ; struttura PAINTSTRUCT
   LOCAL    paintRect   :RECT          ; area di output
   LOCAL    paintDC     :HDC           ; handle to DC
   LOCAL    oldFont     :HFONT         ; handle to font
   LOCAL    counter     :DWORD         ; contatore
   LOCAL    angolo      :DWORD         ; inclinazione stringa

   lea      eax, paintStruct
   call     BeginPaint, hwnd, eax      
   mov      paintDC, eax

   call     SetBkMode, paintDC, TRANSPARENT

   MAKE_COLORREF 0, 250, 0
   call     SetTextColor, paintDC, eax
   call     TextOut, paintDC, 10, 10, offset strOut1, LEN_STROUT1

   MAKE_COLORREF 250, 250, 0
   call     SetTextColor, paintDC, eax
   mov      counter, 8
   mov      angolo, 0
fontRotateLoop:
   call     SetFont, angolo
   call     SelectObject, paintDC, fontHandle
   mov      oldFont, eax
   call     TextOut, paintDC, 300, 250, offset strOut2, LEN_STROUT2
   call     SelectObject, paintDC, oldFont
   add      angolo, 450
   dec      counter
   jnz      fontRotateLoop

   call     SetFont, 0
   call     SelectObject, paintDC, fontHandle
   mov      oldFont, eax
   lea      eax, paintRect
   call     GetClientRect, hwnd, eax
   MAKE_COLORREF 150, 0, 0
   call     SetTextColor, paintDC, eax
   lea      eax, paintRect
   call     DrawText, paintDC, offset strOut3, -1, eax, (DT_SINGLELINE OR DT_CENTER OR DT_VCENTER)
   call     SelectObject, paintDC, oldFont

   lea      eax, paintStruct
   call     EndPaint, hwnd, eax

   ret

FontWin_OnPaint endp

;------------------------------------------------------;
; void Cls_OnClose(HWND hwnd);                         ;
;------------------------------------------------------;
; risposta al messaggio WM_CLOSE                       ;
;------------------------------------------------------;

FontWin_OnClose proc hwnd :DWORD

   call     MessageBox, hwnd, offset msgClose, offset msgTitolo, MB_YESNO OR MB_ICONQUESTION

   ret               ; eax = return value (IDYES o IDNO)
    
FontWin_OnClose endp

;------------------------------------------------------;
; void Cls_OnDestroy(HWND hwnd);                       ;
;------------------------------------------------------;
; risposta al messaggio WM_DESTROY                     ;
;------------------------------------------------------;

FontWin_OnDestroy proc hwnd :DWORD

   cmp      fontHandle, 0
   je       short ondestroy_continue
   call     DeleteObject, fontHandle
ondestroy_continue:
   call     PostQuitMessage, NULL

   ret

FontWin_OnDestroy endp

;**********************************************;
;         libreria di procedure varie          ;
;**********************************************;

; void SetFont(DWORD angolazione)

SetFont proc angolazione :DWORD

   MOV32    fontStruct.lfEscapement, angolazione   

   cmp      fontHandle, 0
   je       short setfont_continue
   call     DeleteObject, fontHandle
setfont_continue:
   call     CreateFontIndirect, offset fontStruct
   mov      fontHandle, eax

   ret

SetFont endp

; void MemSet(DWORD *ptrMem, DWORD fillValue, DWORD fillSize)

MemSet proc ptrMem :DWORD, fillValue :DWORD, fillSize :DWORD

   push     edi                        ; salva il contenuto di edi

   mov      edi, ptrMem                ; edi punta al blocco di memoria da inizializzare
   mov      eax, fillValue             ; al = byte ptr fillValue[0] (inizializzatore)
   mov      ecx, fillSize              ; ecx = n. byte da riempire (contatore)
   cld                                 ; DF = 0 (incremento automatico puntatori)
   rep      stosb                      ; riempie [ptrMem] con fillValue byte
   
   pop      edi                        ; ripristina il vecchio contenuto di edi
   ret

MemSet endp

; void StrCpy(CHAR *strTo, CHAR *strFrom);

StrCpy proc strTo :DWORD, strFrom :DWORD

   mov      ecx, strFrom               ; ecx punta a strFrom
   mov      edx, strTo                 ; edx punta a strto
strcpy_loop:
   mov      al, [ecx]                  ; copia un byte da
   mov      [edx], al                  ; [ecx] a [edx]
   inc      ecx                        ; prossimo byte sorgente
   inc      edx                        ; prossimo byte destinaz.
   test     al, al                     ; fine stringa ?
   jnz      strcpy_loop

   ret

StrCpy endp

;**********************************************;
;                 fine libreria                ;
;**********************************************;

; -------------------- fine blocco procedure -------------------

_TEXT       ENDS

; ##############################################################

   END      start                   ; fine del modulo
